// -*- c++ -*-
// Generated by assa-genesis
//------------------------------------------------------------------------------
// $Id: Granule.h,v 1.7 2004/06/04 23:08:03 vlad Exp $
//------------------------------------------------------------------------------
//                            Granule.h
//------------------------------------------------------------------------------
//  Copyright (c) 2004 by Vladislav Grinchenko 
//
//  This program is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License   
//  as published by the Free Software Foundation; either version  
//  2 of the License, or (at your option) any later version.      
//------------------------------------------------------------------------------
//
// Date   : Wed Dec 31 23:18:34 2003
//
//------------------------------------------------------------------------------
#ifndef Granule_H
#define Granule_H

#ifdef HAVE_CONFIG_H
#    include "config.h"
#endif
#include <string>
using std::string;
#include <gtkmm.h>

#include <assa/GenServer.h>
#include <assa/Singleton.h>
#include <assa/TimeVal.h>
#include "DeckManager.h"

class MainWindow;

class Granule :
    public virtual SigC::Object,
    public ASSA::GenServer,
    public ASSA::Singleton<Granule>
{
public:
    Granule ();
    ~Granule ();

	virtual void init (int* argc_, char* argv_[], const char* help_);
    virtual void initServer ();
    virtual void processServer ();

	MainWindow*  get_main_window () { return m_main_window; }
	DeckManager* get_deck_mgr    () { return &m_deck_mgr; }

    bool timer_cb ();

private:
	void dump_package_envs ();

private:
	ASSA::TimeVal    m_timeout;
    std::string      m_gtk_options;
    Gtk::Main*       m_kit;
    MainWindow*      m_main_window;
	DeckManager      m_deck_mgr;
};


/* Useful definitions */

#define GRANULE  Granule::getInstance()
#define REACTOR  GRANULE->getReactor()
#define MAINWIN  GRANULE->get_main_window()
#define DECKMGR  MAINWIN->get_deck_manager()
#define DECKLIST MAINWIN->get_deck_list()
#define CARDBOX  MAINWIN->get_cardbox()
#define TOPMENUBAR MAINWIN->get_top_menubar()

/**
 * Name: timer_cb()
 * Description: Run Reactor's event loop.
 */
inline bool
Granule::
timer_cb ()
{
	ASSA::TimeVal tv (m_timeout);
    REACTOR->waitForEvents (&tv);
    return true;
}


#endif // Granule_H

